diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/test/wifi-ie-fragment-test.cc ns-3.39/src/wifi/test/wifi-ie-fragment-test.cc
--- ns-3.38/src/wifi/test/wifi-ie-fragment-test.cc	2023-03-16 20:54:23.872869300 -0700
+++ ns-3.39/src/wifi/test/wifi-ie-fragment-test.cc	2023-07-05 14:23:48.129428400 -0700
@@ -19,15 +19,21 @@
 
 #include "ns3/header-serialization-test.h"
 #include "ns3/log.h"
+#include "ns3/supported-rates.h"
 #include "ns3/wifi-information-element.h"
+#include "ns3/wifi-mgt-header.h"
 
 #include <list>
 #include <numeric>
+#include <optional>
 
 using namespace ns3;
 
 NS_LOG_COMPONENT_DEFINE("WifiIeFragmentTest");
 
+/// whether the test Information Element includes an Element ID Extension field
+static bool g_extendedIe = false;
+
 /**
  * \ingroup wifi-test
  * \ingroup tests
@@ -205,30 +211,31 @@
  *
  * Test header that can contain multiple test information elements.
  */
-class TestHeader : public Header
+class TestHeader
+    : public WifiMgtHeader<TestHeader, std::tuple<std::vector<TestWifiInformationElement>>>
 {
+    friend class WifiMgtHeader<TestHeader, std::tuple<std::vector<TestWifiInformationElement>>>;
+
   public:
+    ~TestHeader() override = default;
+
     /**
      * \brief Get the type ID.
      * \return the object TypeId
      */
     static TypeId GetTypeId();
 
-    TypeId GetInstanceTypeId() const override;
-    uint32_t GetSerializedSize() const override;
-    void Serialize(Buffer::Iterator start) const override;
-    uint32_t Deserialize(Buffer::Iterator start) override;
-    void Print(std::ostream& os) const override;
-
     /**
-     * Append the given wifi test information element.
-     *
-     * \param element the given wifi test information element
+     * \return the TypeId for this object.
      */
-    void AddTestIe(TestWifiInformationElement&& element);
+    TypeId GetInstanceTypeId() const override;
 
   private:
-    std::list<TestWifiInformationElement> m_elements; ///< test information elements
+    /**
+     * \param optElem the MultiLinkElement object to initialize for deserializing the
+     *                information element into
+     */
+    void InitForDeserialization(std::optional<TestWifiInformationElement>& optElem);
 };
 
 NS_OBJECT_ENSURE_REGISTERED(TestHeader);
@@ -250,60 +257,9 @@
 }
 
 void
-TestHeader::Print(std::ostream& os) const
-{
-}
-
-uint32_t
-TestHeader::GetSerializedSize() const
-{
-    uint32_t size = 0;
-    for (const auto& elem : m_elements)
-    {
-        size += elem.GetSerializedSize();
-    }
-    return size;
-}
-
-void
-TestHeader::Serialize(Buffer::Iterator start) const
+TestHeader::InitForDeserialization(std::optional<TestWifiInformationElement>& optElem)
 {
-    NS_LOG_FUNCTION(this);
-    for (const auto& elem : m_elements)
-    {
-        start = elem.Serialize(start);
-    }
-}
-
-uint32_t
-TestHeader::Deserialize(Buffer::Iterator start)
-{
-    NS_LOG_FUNCTION(this);
-    Buffer::Iterator i = start;
-    m_elements.clear();
-
-    while (!i.IsEnd())
-    {
-        std::optional<TestWifiInformationElement> elem;
-        i = WifiInformationElement::DeserializeIfPresent(elem, i, true);
-        if (!elem.has_value())
-        {
-            // try deserializing the test IE without Element ID Extension field
-            i = WifiInformationElement::DeserializeIfPresent(elem, i, false);
-        }
-        if (elem.has_value())
-        {
-            m_elements.push_back(std::move(*elem));
-        }
-    }
-    return i.GetDistanceFrom(start);
-}
-
-void
-TestHeader::AddTestIe(TestWifiInformationElement&& element)
-{
-    NS_LOG_FUNCTION(this);
-    m_elements.push_back(std::move(element));
+    optElem.emplace(g_extendedIe);
 }
 
 /**
@@ -376,6 +332,7 @@
     uint16_t limit = m_extended ? 254 : 255;
 
     TestHeader header;
+    g_extendedIe = m_extended;
 
     /*
      * Add an IE (containing 2 subelements). No fragmentation occurs
@@ -409,7 +366,7 @@
                             sub02Size - 2); // subelement 2 Length
     }
 
-    header.AddTestIe(std::move(testIe));
+    header.Get<TestWifiInformationElement>().push_back(std::move(testIe));
     uint32_t expectedHdrSize = 2 + 255;
     NS_TEST_EXPECT_MSG_EQ(header.GetSerializedSize(), expectedHdrSize, "Unexpected header size");
     TestHeaderSerialization(header);
@@ -450,7 +407,7 @@
                             1); // the length of the second element fragment is 1
     }
 
-    header.AddTestIe(std::move(testIe));
+    header.Get<TestWifiInformationElement>().push_back(std::move(testIe));
     expectedHdrSize += 2 + 255  // first fragment
                        + 2 + 1; // second fragment
     NS_TEST_EXPECT_MSG_EQ(header.GetSerializedSize(), expectedHdrSize, "Unexpected header size");
@@ -493,7 +450,7 @@
         CheckSerializedByte(buffer, 2 + 255 + 1, 255); // maximum length for second element fragment
     }
 
-    header.AddTestIe(std::move(testIe));
+    header.Get<TestWifiInformationElement>().push_back(std::move(testIe));
     expectedHdrSize += 2 + 255    // first fragment
                        + 2 + 255; // second fragment
     NS_TEST_EXPECT_MSG_EQ(header.GetSerializedSize(), expectedHdrSize, "Unexpected header size");
@@ -544,7 +501,7 @@
         CheckSerializedByte(buffer, 2 * (2 + 255) + 1, 1); // the length of the third fragment is 1
     }
 
-    header.AddTestIe(std::move(testIe));
+    header.Get<TestWifiInformationElement>().push_back(std::move(testIe));
     expectedHdrSize += 2 + 255   // first fragment
                        + 2 + 255 // second fragment
                        + 2 + 1;  // third fragment
@@ -578,7 +535,7 @@
                             (m_extended ? 3 : 2)); // length of the second element fragment
     }
 
-    header.AddTestIe(std::move(testIe));
+    header.Get<TestWifiInformationElement>().push_back(std::move(testIe));
     expectedHdrSize += 2 + 255                     // first fragment
                        + 2 + (m_extended ? 3 : 2); // second fragment
     NS_TEST_EXPECT_MSG_EQ(header.GetSerializedSize(), expectedHdrSize, "Unexpected header size");
@@ -623,7 +580,7 @@
                             1); // Length for second subelement fragment
     }
 
-    header.AddTestIe(std::move(testIe));
+    header.Get<TestWifiInformationElement>().push_back(std::move(testIe));
     expectedHdrSize += 2 + 255                     // first fragment
                        + 2 + (m_extended ? 6 : 5); // second fragment
     NS_TEST_EXPECT_MSG_EQ(header.GetSerializedSize(), expectedHdrSize, "Unexpected header size");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/test/wifi-mac-ofdma-test.cc ns-3.39/src/wifi/test/wifi-mac-ofdma-test.cc
--- ns-3.38/src/wifi/test/wifi-mac-ofdma-test.cc	2023-03-16 20:54:23.872869300 -0700
+++ ns-3.39/src/wifi/test/wifi-mac-ofdma-test.cc	2023-07-05 14:23:48.129428400 -0700
@@ -153,11 +153,17 @@
                                  ? GetMaxSizeOfQosNullAmpdu(m_trigger)
                                  : 3500; // allows aggregation of 2 MPDUs in TB PPDUs
 
-        Time duration =
-            WifiPhy::CalculateTxDuration(ampduSize,
-                                         txVector,
-                                         m_apMac->GetWifiPhy()->GetPhyBand(),
-                                         m_apMac->GetStaList(SINGLE_LINK_OP_ID).begin()->first);
+        auto staList = m_apMac->GetStaList(SINGLE_LINK_OP_ID);
+        // ignore non-HE stations
+        for (auto it = staList.begin(); it != staList.end();)
+        {
+            it = m_apMac->GetHeSupported(it->second) ? std::next(it) : staList.erase(it);
+        }
+
+        Time duration = WifiPhy::CalculateTxDuration(ampduSize,
+                                                     txVector,
+                                                     m_apMac->GetWifiPhy()->GetPhyBand(),
+                                                     staList.begin()->first);
 
         uint16_t length;
         std::tie(length, duration) = HePhy::ConvertHeTbPpduDurationToLSigLength(
@@ -200,7 +206,12 @@
     {
         // try to send a DL MU PPDU
         m_psduMap.clear();
-        const std::map<uint16_t, Mac48Address>& staList = m_apMac->GetStaList(SINGLE_LINK_OP_ID);
+        auto staList = m_apMac->GetStaList(SINGLE_LINK_OP_ID);
+        // ignore non-HE stations
+        for (auto it = staList.cbegin(); it != staList.cend();)
+        {
+            it = m_apMac->GetHeSupported(it->second) ? std::next(it) : staList.erase(it);
+        }
         NS_ABORT_MSG_IF(staList.size() != 4, "There must be 4 associated stations");
 
         /* Initialize TX params */
@@ -292,7 +303,12 @@
     m_txVector.SetTxPowerLevel(
         GetWifiRemoteStationManager(SINGLE_LINK_OP_ID)->GetDefaultTxPowerLevel());
 
-    const std::map<uint16_t, Mac48Address>& staList = m_apMac->GetStaList(SINGLE_LINK_OP_ID);
+    auto staList = m_apMac->GetStaList(SINGLE_LINK_OP_ID);
+    // ignore non-HE stations
+    for (auto it = staList.cbegin(); it != staList.cend();)
+    {
+        it = m_apMac->GetHeSupported(it->second) ? std::next(it) : staList.erase(it);
+    }
     NS_ABORT_MSG_IF(staList.size() != 4, "There must be 4 associated stations");
 
     HeRu::RuType ruType;
@@ -300,19 +316,19 @@
     {
     case 20:
         ruType = HeRu::RU_52_TONE;
-        m_txVector.SetRuAllocation({112});
+        m_txVector.SetRuAllocation({112}, 0);
         break;
     case 40:
         ruType = HeRu::RU_106_TONE;
-        m_txVector.SetRuAllocation({96, 96});
+        m_txVector.SetRuAllocation({96, 96}, 0);
         break;
     case 80:
         ruType = HeRu::RU_242_TONE;
-        m_txVector.SetRuAllocation({192, 192, 192, 192});
+        m_txVector.SetRuAllocation({192, 192, 192, 192}, 0);
         break;
     case 160:
         ruType = HeRu::RU_484_TONE;
-        m_txVector.SetRuAllocation({200, 200, 200, 200, 200, 200, 200, 200});
+        m_txVector.SetRuAllocation({200, 200, 200, 200, 200, 200, 200, 200}, 0);
         break;
     default:
         NS_ABORT_MSG("Unsupported channel width");
@@ -529,6 +545,8 @@
     default:
         NS_ABORT_MSG("Unhandled channel width (" << m_channelWidth << " MHz)");
     }
+
+    m_txPsdus.reserve(35);
 }
 
 OfdmaAckSequenceTest::~OfdmaAckSequenceTest()
@@ -993,27 +1011,6 @@
     NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, qosNullNavEnd, "Duration/ID in QoS Null is too short");
     NS_TEST_EXPECT_MSG_LT(qosNullNavEnd, navEnd + tolerance, "Duration/ID in QoS Null is too long");
 
-    // the AP sends another MU-RTS Trigger Frame to protect the Basic TF
-    NS_TEST_ASSERT_MSG_GT_OR_EQ(m_txPsdus.size(), 15, "Expected at least 15 transmitted packet");
-    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[10].psduMap.size() == 1 &&
-                           m_txPsdus[10].psduMap[SU_STA_ID]->GetHeader(0).IsTrigger() &&
-                           m_txPsdus[10].psduMap[SU_STA_ID]->GetHeader(0).GetAddr1().IsBroadcast()),
-                          true,
-                          "Expected a Trigger Frame");
-    m_txPsdus[10].psduMap[SU_STA_ID]->GetPayload(0)->PeekHeader(trigger);
-    NS_TEST_EXPECT_MSG_EQ(trigger.IsMuRts(), true, "Expected an MU-RTS Trigger Frame");
-    NS_TEST_EXPECT_MSG_EQ(trigger.GetNUserInfoFields(),
-                          4,
-                          "Expected one User Info field per station");
-    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[10].txVector.GetChannelWidth(),
-                          m_channelWidth,
-                          "Expected the MU-RTS to occupy the entire channel width");
-    for (const auto& userInfo : trigger)
-    {
-        NS_TEST_EXPECT_MSG_EQ(+userInfo.GetMuRtsRuAllocation(),
-                              +m_muRtsRuAllocation,
-                              "Unexpected RU Allocation value in MU-RTS");
-    }
     tEnd = m_txPsdus[9].endTx;
     tStart = m_txPsdus[10].startTx;
     NS_TEST_EXPECT_MSG_LT(tEnd + ifs, tStart, "Basic Trigger Frame sent too early");
@@ -1027,89 +1024,136 @@
         NS_TEST_EXPECT_MSG_LT(muRtsNavEnd, navEnd + tolerance, "Duration/ID in MU-RTS is too long");
     }
 
-    // NAV end is now set by the Duration/ID of the second MU-RTS TF
-    tEnd = m_txPsdus[10].endTx;
-    navEnd = tEnd + m_txPsdus[10].psduMap[SU_STA_ID]->GetDuration();
-
-    // A first STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
-    NS_TEST_EXPECT_MSG_EQ(
-        (m_txPsdus[11].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
-         m_txPsdus[11].psduMap.size() == 1 &&
-         m_txPsdus[11].psduMap.begin()->second->GetNMpdus() == 1 &&
-         m_txPsdus[11].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
-        true,
-        "Expected a CTS frame");
-    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[11].txVector.GetChannelWidth(),
-                          m_channelWidth,
-                          "Expected the CTS to occupy the entire channel width");
-
-    tStart = m_txPsdus[11].startTx;
-    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
-    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
-    ctsNavEnd = m_txPsdus[11].endTx + m_txPsdus[11].psduMap[SU_STA_ID]->GetDuration();
-    // navEnd <= ctsNavEnd < navEnd + tolerance
-    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
-    NS_TEST_EXPECT_MSG_LT(ctsNavEnd, navEnd + tolerance, "Duration/ID in CTS frame is too long");
-
-    // A second STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
-    NS_TEST_EXPECT_MSG_EQ(
-        (m_txPsdus[12].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
-         m_txPsdus[12].psduMap.size() == 1 &&
-         m_txPsdus[12].psduMap.begin()->second->GetNMpdus() == 1 &&
-         m_txPsdus[12].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
-        true,
-        "Expected a CTS frame");
-    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[12].txVector.GetChannelWidth(),
-                          m_channelWidth,
-                          "Expected the CTS to occupy the entire channel width");
-
-    tStart = m_txPsdus[12].startTx;
-    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
-    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
-    ctsNavEnd = m_txPsdus[12].endTx + m_txPsdus[12].psduMap[SU_STA_ID]->GetDuration();
-    // navEnd <= ctsNavEnd < navEnd + tolerance
-    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
-    NS_TEST_EXPECT_MSG_LT(ctsNavEnd, navEnd + tolerance, "Duration/ID in CTS frame is too long");
+    // if the TXOP limit is not null, MU-RTS protection is not used because the next transmission
+    // is protected by the previous MU-RTS Trigger Frame
+    if (m_txopLimit == 0)
+    {
+        // the AP sends another MU-RTS Trigger Frame to protect the Basic TF
+        NS_TEST_ASSERT_MSG_GT_OR_EQ(m_txPsdus.size(),
+                                    15,
+                                    "Expected at least 15 transmitted packet");
+        NS_TEST_EXPECT_MSG_EQ(
+            (m_txPsdus[10].psduMap.size() == 1 &&
+             m_txPsdus[10].psduMap[SU_STA_ID]->GetHeader(0).IsTrigger() &&
+             m_txPsdus[10].psduMap[SU_STA_ID]->GetHeader(0).GetAddr1().IsBroadcast()),
+            true,
+            "Expected a Trigger Frame");
+        m_txPsdus[10].psduMap[SU_STA_ID]->GetPayload(0)->PeekHeader(trigger);
+        NS_TEST_EXPECT_MSG_EQ(trigger.IsMuRts(), true, "Expected an MU-RTS Trigger Frame");
+        NS_TEST_EXPECT_MSG_EQ(trigger.GetNUserInfoFields(),
+                              4,
+                              "Expected one User Info field per station");
+        NS_TEST_EXPECT_MSG_EQ(m_txPsdus[10].txVector.GetChannelWidth(),
+                              m_channelWidth,
+                              "Expected the MU-RTS to occupy the entire channel width");
+        for (const auto& userInfo : trigger)
+        {
+            NS_TEST_EXPECT_MSG_EQ(+userInfo.GetMuRtsRuAllocation(),
+                                  +m_muRtsRuAllocation,
+                                  "Unexpected RU Allocation value in MU-RTS");
+        }
+
+        // NAV end is now set by the Duration/ID of the second MU-RTS TF
+        tEnd = m_txPsdus[10].endTx;
+        navEnd = tEnd + m_txPsdus[10].psduMap[SU_STA_ID]->GetDuration();
+
+        // A first STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
+        NS_TEST_EXPECT_MSG_EQ(
+            (m_txPsdus[11].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
+             m_txPsdus[11].psduMap.size() == 1 &&
+             m_txPsdus[11].psduMap.begin()->second->GetNMpdus() == 1 &&
+             m_txPsdus[11].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
+            true,
+            "Expected a CTS frame");
+        NS_TEST_EXPECT_MSG_EQ(m_txPsdus[11].txVector.GetChannelWidth(),
+                              m_channelWidth,
+                              "Expected the CTS to occupy the entire channel width");
+
+        tStart = m_txPsdus[11].startTx;
+        NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
+        NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
+        ctsNavEnd = m_txPsdus[11].endTx + m_txPsdus[11].psduMap[SU_STA_ID]->GetDuration();
+        // navEnd <= ctsNavEnd < navEnd + tolerance
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
+        NS_TEST_EXPECT_MSG_LT(ctsNavEnd,
+                              navEnd + tolerance,
+                              "Duration/ID in CTS frame is too long");
 
-    // A third STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
-    NS_TEST_EXPECT_MSG_EQ(
-        (m_txPsdus[13].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
-         m_txPsdus[13].psduMap.size() == 1 &&
-         m_txPsdus[13].psduMap.begin()->second->GetNMpdus() == 1 &&
-         m_txPsdus[13].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
-        true,
-        "Expected a CTS frame");
-    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[13].txVector.GetChannelWidth(),
-                          m_channelWidth,
-                          "Expected the CTS to occupy the entire channel width");
+        // A second STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
+        NS_TEST_EXPECT_MSG_EQ(
+            (m_txPsdus[12].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
+             m_txPsdus[12].psduMap.size() == 1 &&
+             m_txPsdus[12].psduMap.begin()->second->GetNMpdus() == 1 &&
+             m_txPsdus[12].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
+            true,
+            "Expected a CTS frame");
+        NS_TEST_EXPECT_MSG_EQ(m_txPsdus[12].txVector.GetChannelWidth(),
+                              m_channelWidth,
+                              "Expected the CTS to occupy the entire channel width");
+
+        tStart = m_txPsdus[12].startTx;
+        NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
+        NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
+        ctsNavEnd = m_txPsdus[12].endTx + m_txPsdus[12].psduMap[SU_STA_ID]->GetDuration();
+        // navEnd <= ctsNavEnd < navEnd + tolerance
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
+        NS_TEST_EXPECT_MSG_LT(ctsNavEnd,
+                              navEnd + tolerance,
+                              "Duration/ID in CTS frame is too long");
 
-    tStart = m_txPsdus[13].startTx;
-    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
-    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
-    ctsNavEnd = m_txPsdus[13].endTx + m_txPsdus[13].psduMap[SU_STA_ID]->GetDuration();
-    // navEnd <= ctsNavEnd < navEnd + tolerance
-    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
-    NS_TEST_EXPECT_MSG_LT(ctsNavEnd, navEnd + tolerance, "Duration/ID in CTS frame is too long");
+        // A third STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
+        NS_TEST_EXPECT_MSG_EQ(
+            (m_txPsdus[13].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
+             m_txPsdus[13].psduMap.size() == 1 &&
+             m_txPsdus[13].psduMap.begin()->second->GetNMpdus() == 1 &&
+             m_txPsdus[13].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
+            true,
+            "Expected a CTS frame");
+        NS_TEST_EXPECT_MSG_EQ(m_txPsdus[13].txVector.GetChannelWidth(),
+                              m_channelWidth,
+                              "Expected the CTS to occupy the entire channel width");
+
+        tStart = m_txPsdus[13].startTx;
+        NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
+        NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
+        ctsNavEnd = m_txPsdus[13].endTx + m_txPsdus[13].psduMap[SU_STA_ID]->GetDuration();
+        // navEnd <= ctsNavEnd < navEnd + tolerance
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
+        NS_TEST_EXPECT_MSG_LT(ctsNavEnd,
+                              navEnd + tolerance,
+                              "Duration/ID in CTS frame is too long");
 
-    // A fourth STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
-    NS_TEST_EXPECT_MSG_EQ(
-        (m_txPsdus[14].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
-         m_txPsdus[14].psduMap.size() == 1 &&
-         m_txPsdus[14].psduMap.begin()->second->GetNMpdus() == 1 &&
-         m_txPsdus[14].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
-        true,
-        "Expected a CTS frame");
-    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[14].txVector.GetChannelWidth(),
-                          m_channelWidth,
-                          "Expected the CTS to occupy the entire channel width");
+        // A fourth STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
+        NS_TEST_EXPECT_MSG_EQ(
+            (m_txPsdus[14].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
+             m_txPsdus[14].psduMap.size() == 1 &&
+             m_txPsdus[14].psduMap.begin()->second->GetNMpdus() == 1 &&
+             m_txPsdus[14].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
+            true,
+            "Expected a CTS frame");
+        NS_TEST_EXPECT_MSG_EQ(m_txPsdus[14].txVector.GetChannelWidth(),
+                              m_channelWidth,
+                              "Expected the CTS to occupy the entire channel width");
+
+        tStart = m_txPsdus[14].startTx;
+        NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
+        NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
+        ctsNavEnd = m_txPsdus[14].endTx + m_txPsdus[14].psduMap[SU_STA_ID]->GetDuration();
+        // navEnd <= ctsNavEnd < navEnd + tolerance
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
+        NS_TEST_EXPECT_MSG_LT(ctsNavEnd,
+                              navEnd + tolerance,
+                              "Duration/ID in CTS frame is too long");
 
-    tStart = m_txPsdus[14].startTx;
-    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
-    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
-    ctsNavEnd = m_txPsdus[14].endTx + m_txPsdus[14].psduMap[SU_STA_ID]->GetDuration();
-    // navEnd <= ctsNavEnd < navEnd + tolerance
-    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
-    NS_TEST_EXPECT_MSG_LT(ctsNavEnd, navEnd + tolerance, "Duration/ID in CTS frame is too long");
+        tEnd = m_txPsdus[14].endTx;
+    }
+    else
+    {
+        // insert 5 elements in m_txPsdus to align the index of the following frames in the
+        // two cases (TXOP limit null and not null)
+        m_txPsdus.insert(std::next(m_txPsdus.begin(), 10), 5, {});
+        tEnd = m_txPsdus[9].endTx;
+    }
 
     // the AP sends a Basic Trigger Frame to solicit QoS data frames
     NS_TEST_ASSERT_MSG_GT_OR_EQ(m_txPsdus.size(), 21, "Expected at least 21 transmitted packets");
@@ -1123,7 +1167,6 @@
     NS_TEST_EXPECT_MSG_EQ(trigger.GetNUserInfoFields(),
                           4,
                           "Expected one User Info field per station");
-    tEnd = m_txPsdus[14].endTx;
     tStart = m_txPsdus[15].startTx;
     NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Basic Trigger Frame sent too early");
     NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "Basic Trigger Frame sent too late");
